Loading...
Searching...
No Matches
Gudhi::persistence_matrix::Chain_representative_cycles< Master_matrix > Class Template Reference
Persistence Matrix

Class managing the representative cycles for Chain_matrix if the option was enabled. More...

`#include <gudhi/Persistence_matrix/chain_rep_cycles.h>`

## Public Types

using | Bar = typename Master_matrix::Bar
using | Cycle = typename Master_matrix::Cycle
using | Column_container = typename Master_matrix::Column_container

## Public Member Functions

| Chain_representative_cycles ()
| Default constructor.
| Chain_representative_cycles (const Chain_representative_cycles &matrixToCopy)
| Copy constructor.
| Chain_representative_cycles (Chain_representative_cycles &&other) noexcept
| Move constructor.
void | update_representative_cycles ()
| Computes the current representative cycles of the matrix.
const std::vector< Cycle > & | get_representative_cycles ()
| Returns the current representative cycles. If the matrix is modified later after the first call, update_representative_cycles has to be called to update the returned cycles.
const Cycle & | get_representative_cycle (const Bar &bar)
| Returns the representative cycle corresponding to the given bar. If the matrix is modified later after the first call, update_representative_cycles has to be called to update the returned cycles.
Chain_representative_cycles & | operator= (Chain_representative_cycles other)
| Assign operator.

## Friends

void | swap (Chain_representative_cycles &base1, Chain_representative_cycles &base2)
| Swap operator.

## Detailed Description

template<class Master_matrix>
class Gudhi::persistence_matrix::Chain_representative_cycles< Master_matrix >

Class managing the representative cycles for Chain_matrix if the option was enabled.

Template Parameters

  Master_matrix | An instantiation of Matrix from which all types and options are deduced.

## Member Typedef Documentation

## Bar

template<class Master_matrix>

using Gudhi::persistence_matrix::Chain_representative_cycles< Master_matrix >::Bar = typename Master_matrix::Bar

Bar type.

## Column_container

template<class Master_matrix>

using Gudhi::persistence_matrix::Chain_representative_cycles< Master_matrix >::Column_container = typename Master_matrix::Column_container

Column container type.

## Cycle

template<class Master_matrix>

using Gudhi::persistence_matrix::Chain_representative_cycles< Master_matrix >::Cycle = typename Master_matrix::Cycle

Cycle type.

## Constructor & Destructor Documentation

## Chain_representative_cycles() [1/2]

template<class Master_matrix>

Gudhi::persistence_matrix::Chain_representative_cycles< Master_matrix >::Chain_representative_cycles | ( | const Chain_representative_cycles< Master_matrix > & | matrixToCopy | ) |

inline

Copy constructor.

Parameters

  matrixToCopy | Matrix to copy.

## Chain_representative_cycles() [2/2]

template<class Master_matrix>

Gudhi::persistence_matrix::Chain_representative_cycles< Master_matrix >::Chain_representative_cycles | ( | Chain_representative_cycles< Master_matrix > && | other | ) |

inline noexcept

Move constructor.

Parameters

  other | Matrix to move.

## Member Function Documentation

## get_representative_cycle()

template<class Master_matrix>

const Chain_representative_cycles< Master_matrix >::Cycle & Gudhi::persistence_matrix::Chain_representative_cycles< Master_matrix >::get_representative_cycle | ( | const Bar & | bar | ) |

inline

Returns the representative cycle corresponding to the given bar. If the matrix is modified later after the first call, update_representative_cycles has to be called to update the returned cycles.

Parameters

  bar | Bar corresponding to the wanted representative cycle.

Returns
  A const reference to the representative cycle.

## get_representative_cycles()

template<class Master_matrix>

const std::vector< typename Chain_representative_cycles< Master_matrix >::Cycle > & Gudhi::persistence_matrix::Chain_representative_cycles< Master_matrix >::get_representative_cycles | ( |  | ) |

inline

Returns the current representative cycles. If the matrix is modified later after the first call, update_representative_cycles has to be called to update the returned cycles.

Returns
  A const reference to a vector of Matrix::Cycle containing all representative cycles.

The documentation for this class was generated from the following file:

- include/gudhi/Persistence_matrix/chain_rep_cycles.h